<template>
    <form class="form-signin" action="" method="post">
        <input name="csrfmiddlewaretoken" type="hidden" :value="csrfToken" />
        <label for="inputEmail" class="sr-only">Email</label>
        <input v-model="email" name="email" type="email" id="inputEmail" class="form-control first" placeholder="Email" required autofocus>
        <PasswordInput v-model="password" name="password" label="Пароль" required placeholder="Введите пароль" />
        <button
            class="btn btn-lg btn-primary btn-block"
            type="submit"
            :disabled="!canSubmit"
        >Вход</button>

        <div>{{count}}</div>
        <button type="button" @click="makeIncrement">+1</button>
    </form>
</template>

<script>
    import {mapActions, mapState} from "vuex";
    import PasswordInput from "@/components/PasswordInput";

    export default {
        name: 'Auth',
        components: {PasswordInput},
        data() {
            return {
                csrfToken: null,
                email: null,
                password: null
            };
        },
        beforeMount() {
            const csrfInput = document.querySelector('[name="csrfmiddlewaretoken"]');
            this.csrfToken = csrfInput.value;
        },
        computed: {
            ...mapState(['count']),
            canSubmit() {
                if (!this.email || !this.password) {
                    return false;
                }
                return this.email.length > 3 && this.password.length > 3;
            }
        },
        methods: {
            ...mapActions(['makeIncrement'])
        }
    }
</script>

<style>
</style>
